import { EventEmitter, QueryList, AfterContentInit, ChangeDetectorRef, TemplateRef } from '@angular/core';
import { DataTableColumnTmplComponent } from './tmpl/data-table-column-tmpl.component';
import { CellSelectedEventArg, RowCheckChangeEventArg, RowSelectedEventArg, SortChangeEventArg, DataTablePager } from './data-table.model';
import { DataTableHeadTmplComponent } from './tmpl/data-table-head-tmpl.component';
import { DataTableFootTmplComponent } from './tmpl/data-table-foot-tmpl.component';
import { DataTableTmplsComponent } from './tmpl/data-table-tmpls.component';
import { DataTablePagerTmplComponent } from './tmpl/data-table-pager-tmpl.component';
import { RebirthNGConfig } from '../rebirth-ng.config';
export declare class DataTableComponent implements AfterContentInit {
    private rebirthNGConfig;
    private changeDetectorRef;
    _dataSource: any[];
    emptyRowText: string;
    emptyRowTemplate: TemplateRef<any>;
    checkable: boolean;
    selectable: boolean;
    scrollable: boolean;
    editModel: 'row' | 'cell';
    maxHeight: string;
    type: '' | 'striped' | 'bordered' | 'condensed';
    hover: boolean;
    allChecked: boolean;
    cssClass: string;
    tableWidth: string;
    cellClick: EventEmitter<CellSelectedEventArg>;
    cellDBClick: EventEmitter<CellSelectedEventArg>;
    rowClick: EventEmitter<RowSelectedEventArg>;
    rowDBClick: EventEmitter<RowSelectedEventArg>;
    cellEditStart: EventEmitter<CellSelectedEventArg>;
    cellEditEnd: EventEmitter<CellSelectedEventArg>;
    sortChange: EventEmitter<SortChangeEventArg>;
    rowCheckChange: EventEmitter<RowCheckChangeEventArg>;
    checkAllChange: EventEmitter<boolean>;
    searchQueryChange: EventEmitter<{
        [key: string]: any;
    }>;
    pageIndexChange: EventEmitter<number>;
    columnTemplates: QueryList<DataTableColumnTmplComponent>;
    headTemplate: DataTableHeadTmplComponent;
    footTemplate: DataTableFootTmplComponent;
    pagerTemplate: DataTablePagerTmplComponent;
    dataTableTemplates: DataTableTmplsComponent;
    selectedRowItem: any;
    columns: DataTableColumnTmplComponent[];
    pager: DataTablePager;
    selectedColumnItem: any;
    isCellEdit: boolean;
    editRowItem: any;
    documentClickEvent: EventEmitter<Event>;
    constructor(rebirthNGConfig: RebirthNGConfig, changeDetectorRef: ChangeDetectorRef);
    totalRecord: number;
    pageIndex: number;
    pageSize: number;
    maxPageItems: number;
    dataSource: any[];
    ngAfterContentInit(): void;
    onDocumentClick($event: Event): void;
    onCellClick($event: CellSelectedEventArg): void;
    onCellEditStart($event: CellSelectedEventArg): void;
    onCellEditEnd($event: CellSelectedEventArg): void;
    onCellDBClick($event: CellSelectedEventArg): void;
    onRowClick($event: RowSelectedEventArg): void;
    onRowDBClick($event: RowSelectedEventArg): void;
    onRowCheckChange($event: RowCheckChangeEventArg): void;
    onCheckAllChange($event: boolean): void;
    onSearchQueryChange($event: {
        [key: string]: any;
    }): void;
    onPageChange($event: number): void;
    getCheckRows(): any[];
    getSelectedRowItem(): any[];
    editRow(rowItem: any, editModel: any): void;
    endEditRow(rowItem: any): any;
}
