import { Component, Input, Output, EventEmitter } from '@angular/core';
var TreePanelComponent = (function () {
    function TreePanelComponent() {
        this.checkable = false;
        this.lazyLoad = false;
        this.allowDraggable = false;
        this.allowMutipleSelected = false;
        this.nodeItemCheckedChanged = new EventEmitter();
    }
    TreePanelComponent.prototype.onNodeItemCheckedChanged = function (node) {
        this.nodeItemCheckedChanged.emit(node);
    };
    return TreePanelComponent;
}());
export { TreePanelComponent };
TreePanelComponent.decorators = [
    { type: Component, args: [{
                selector: 're-tree-panel',
                template: "\n    <ul class=\"list-unstyled\">\n      <li reTreeNode *ngFor=\"let node of treeData\"\n          [node]=\"node\"\n          [textField]=\"textField\"\n          [valueField]=\"valueField\"\n          [iconField]=\"iconField\"\n          [nodeCssClass]=\"nodeCssClass\"\n          [checkable]=\"checkable\"\n          [lazyLoad]=\"lazyLoad\"\n          [loadingIcon]=\"loadingIcon\"\n          [loadChildren]=\"loadChildren\"\n          [allowDraggable]=\"allowDraggable\"\n          [nodeItemTemplate]=\"nodeItemTemplate\"\n          [nodeItemToolbarTemplate]=\"nodeItemToolbarTemplate\"\n          [leafIcon]=\"leafIcon\"\n          [expendIcon]=\"expendIcon\"\n          [collapseIcon]=\"collapseIcon\"\n          [allowMutipleSelected]=\"allowMutipleSelected\"\n          [parentNode]=\"parentNode\"\n      >\n      </li>\n    </ul>\n  "
            },] },
];
/** @nocollapse */
TreePanelComponent.ctorParameters = function () { return []; };
TreePanelComponent.propDecorators = {
    'treeData': [{ type: Input },],
    'parentNode': [{ type: Input },],
    'valueField': [{ type: Input },],
    'textField': [{ type: Input },],
    'nodeCssClass': [{ type: Input },],
    'iconField': [{ type: Input },],
    'checkable': [{ type: Input },],
    'lazyLoad': [{ type: Input },],
    'loadingIcon': [{ type: Input },],
    'loadChildren': [{ type: Input },],
    'allowDraggable': [{ type: Input },],
    'allowMutipleSelected': [{ type: Input },],
    'nodeItemTemplate': [{ type: Input },],
    'nodeItemToolbarTemplate': [{ type: Input },],
    'leafIcon': [{ type: Input },],
    'expendIcon': [{ type: Input },],
    'collapseIcon': [{ type: Input },],
    'nodeItemCheckedChanged': [{ type: Output },],
};
//# sourceMappingURL=tree-panel.component.js.map