var TRANSITION_END_EVENT = {
    WebkitTransition: 'webkitTransitionEnd',
    MozTransition: 'transitionend',
    OTransition: 'oTransitionEnd otransitionend',
    transition: 'transitionend'
};
function getSupportTransitionEndEvent(elementRef) {
    for (var name_1 in TRANSITION_END_EVENT) {
        if (elementRef.nativeElement && elementRef.nativeElement.style[name_1] !== undefined) {
            return TRANSITION_END_EVENT[name_1];
        }
    }
}
export function animation(renderer, elementRef, duration) {
    if (duration === void 0) { duration = 0; }
    var endEvent = getSupportTransitionEndEvent(elementRef);
    return new Promise(function (resolve) {
        if (endEvent) {
            var listen_1 = renderer.listen(elementRef.nativeElement, endEvent, function () {
                listen_1();
                resolve();
            });
        }
        var timeout = setTimeout(function () {
            resolve();
            clearTimeout(timeout);
        }, duration);
    });
}
export function animationTimeout(duration) {
    if (duration === void 0) { duration = 0; }
    return new Promise(function (resolve) {
        var timeout = setTimeout(function () {
            resolve();
            clearTimeout(timeout);
        }, duration);
    });
}
//# sourceMappingURL=animation-utils.js.map